define([
    "dojo/_base/declare",
    "gridx/Grid",
    "gridx/core/model/cache/Sync",
    "gridx/modules/SingleSort",
    "gridx/modules/VirtualVScroller",
    "gridx/modules/ColumnResizer",
    "dojo/store/Memory",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/_base/array"
],function(declare,Grid,Cache,SingleSort,VirtualVScroller,ColumnResizer,Memory,_WidgetBase,_TemplatedMixin,arrayUtils) {
    return declare([_WidgetBase,_TemplatedMixin],{
        templateString: "<div data-dojo-attach-point='containerNode'></div>",

        store: null,

        grid: null,

        autoHeight: false,

        style: "width:100%;height:100%;",

        _setStoreAttr: function(value) {
            var t = this;
            if (t.grid) {
                t.grid.destroyRecursive();
            }

            t.store = value;
            if (typeof value === "object" && value.data.length > 0) {
                var structure = t._generateStructure();
                t.grid = new Grid({
                    cacheClass: Cache,
                    style: "height:100%",
                    store: t.store,
                    structure: structure,
                    autoHeight: t.autoHeight,
                    modules: [
                        SingleSort,
                        VirtualVScroller
                    ]
                });
                t.domNode.appendChild(t.grid.domNode);
                t.grid.startup();
            }
        },

        _generateStructure: function() {
            // Summary:
            //      Takes a thornberry/report/Report and generates the column structure from it
            var t = this;

            var columnNames = [];
            for (var name in t.store.data[0]) {
                if (name !== t.store.idProperty) {
                    columnNames.push(name);
                }
            }

            var columnId = 0;
            var structure = [];
            arrayUtils.forEach(columnNames,function(columnName) {
                // Set basic column data
                var displayName = escapeText(columnName);
                var gridColumn = {
                    id: ++columnId,
                    name: displayName,
                    field: columnName
                };
                structure.push(gridColumn);
            });

            return structure;
        },

        resize: function() {
            var t = this;
            t.inherited(arguments);
            if (t.grid) {
                t.grid.resize();
            }
        }
    });
});