define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "thornberry/app/Component/_TableFieldEditorMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/text!./Templates/ServiceProvidedBillRate.html",
    "dojo/text!./Templates/LevelOfCareBillRate.html",
    "dojo/text!./Templates/FacilityBillRate.html",
    "dojo/text!./Templates/SupplyBillRate.html",
    "dojo/_base/lang",
    "dojo/aspect",
    "dijit/form/DateTextbox",
    "dijit/form/CurrencyTextBox",
    "dijit/form/ValidationTextBox",
    "dijit/form/Select",
    "dijit/form/Form",
    "dijit/form/Button"
],function(
    declare,
    _EditorComponent,
    _TableFieldEditorMixin,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    serviceProvidedBillRateTemplate,
    levelOfCareBillRateTemplate,
    facilityBillRateTemplate,
    supplyBillRateTemplate,
    lang,
    aspect
) {
    return declare([ _EditorComponent,_TableFieldEditorMixin,_TemplatedMixin,_WidgetsInTemplateMixin],{
        layout: "serviceProvided", // or "levelOfCare", "supply" or "facility"
        templateString: null,

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                onRemove: null,
                onChange: null
            });
        },

        postMixInProperties: function() {
            var t = this;
            t.inherited(arguments);

            var layouts = {
                serviceProvided :   serviceProvidedBillRateTemplate,
                levelOfCare:        levelOfCareBillRateTemplate,
                facility:           facilityBillRateTemplate,
                supply:             supplyBillRateTemplate
            }
            t.templateString = (layouts[t.layout] ? layouts[t.layout] : layouts["typed"]);

            aspect.after(t,"updateModified",function() {
                if (t.props.onChange) {
                    t.props.onChange();
                }
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);
            
            t.addRequirement([
                "effectiveDate",
                "grossAmount",
                "grossRateType",
                "revenueCode"
            ],true);
        },

        _onRemove: function() {
            var t = this;
            if (t.props.onRemove) {
                t.props.onRemove();
            }
        }
    });
});