define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dijit/_WidgetsInTemplateMixin",
    "dijit/_FocusMixin",
    "dijit/registry",
    "thornberry/calendar/DatePicker",
	"dojo/Stateful",
	"dojo/store/Memory",
	"dojo/store/Observable",
	"dojo/Deferred",
	"dojo/dom",
    "dojo/query",
    "dojo/when",
	"dojo/dom-geometry",
    "thornberry/serverRequest",
    "thornberry/UserSettings",
	"dojo/_base/window",
    "dojo/dom-style",
    "dojo/dom-class",
    "dojo/dom-construct",
    "dojo/dom-attr",
	"dojo/_base/fx",
	"dojo/on",
    "dojo/_base/array",
    "dojo/aspect",
    "dojo/date/locale",
    "thornberry/calendar/Calendar",
    "dijit/form/Button",
    "dijit/form/CheckBox",
    "dijit/form/DropDownButton",
    "dijit/DropDownMenu",
    "dijit/MenuItem",
    "dijit/popup",
    "dijit/Dialog",
    "dojo/topic",
    "thornberry/AdvancedEmployeeSearch",
    "thornberry/InfoLink",
    "dojox/form/CheckedMultiSelect",
    "thornberry/report/filter/Search",
    "thornberry/calendar/EventDetails",
    "dijit/ColorPalette"
],function(declare,lang,_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_FocusMixin,registry,DatePicker,Stateful,Memory,Observable,Deferred,dom,query,when,domGeom,serverRequest,UserSettings,baseWindow,domStyle,domClass,domConstruct,domAttr,fx,on,arrayUtils,aspect,locale,Calendar,Button,CheckBox,DropDownButton,DropDownMenu,MenuItem,popup,Dialog,topic,AdvancedEmployeeSearch,InfoLink) {

    var SLIDEDURATION = 600;
    var WIDTH = 400;
    var COLLAPSEDWIDTH = 375;

    var calendarMenu = new DropDownMenu({
        opener: null
    });
    var removeMenuItem = new MenuItem({
        label: "Remove",
        onClick: function() {
            if (calendarMenu.opener) {
                calendarMenu.opener.remove();
            }
        }
    });
    calendarMenu.addChild(removeMenuItem);
    var removeAllMenuItem = new MenuItem({
        label: "Remove All but This",
        onClick: function() {
            if (calendarMenu.opener) {
                calendarMenu.opener.removeAllButThis();
            }
        }
    });
    calendarMenu.addChild(removeAllMenuItem);
    var changeColorMenuItem = new MenuItem({
        label: "Change Color",
        onClick: function() {
            if (calendarMenu.opener && calendarMenu.opener.parent) {
                calendarMenu.opener.parent.openColorSelect(calendarMenu.opener);
            }
        }
    });
    calendarMenu.addChild(changeColorMenuItem);
    popup.moveOffScreen(calendarMenu);
    calendarMenu.startup();

    var CalendarWidget = declare([_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin], {
        baseClass: "calendar-widget",
        templateString: "<div class='${baseClass}'><input data-dojo-attach-point='checkBox' data-dojo-type='dijit/form/CheckBox' checked></input><span data-dojo-attach-point='calendarIcon' class='fas calendar-icon'></span><span class='calendar-name'>${calendar.name} ${calendar.identifier} <span data-dojo-attach-point='infoLinkNode'></span></span><span data-dojo-attach-event='onClick:openMenu' data-dojo-attach-point='calendarMenuNode' style='float:right;font-size:10pt;margin-right:5px;cursor:pointer' class='fas fa-caret-down'></span></div>",
        calendar: null,
        calendarStore: null,
        identifierText: "",
        parent: null,
        infoLink: "",

        postMixInProperties: function() {
			var t = this;
            t.inherited(arguments);
        },

        buildRendering: function() {
			var t = this;
			t.inherited(arguments);
            
            domClass.add(t.calendarIcon,t.calendar.getIconClass());
            domStyle.set(t.calendarIcon,"color",t.calendar.color.toHex());
            domClass.remove(t.domNode,"calendar-inactive");
            if (typeof t.calendar.other.active !== "undefined" && !t.calendar.other.active) {
                domClass.add(t.domNode,"calendar-inactive");
            }

            if (t.calendar.type === "Patient" || t.calendar.type === "Employee") {
                t.infoLinkNode.innerHTML = " <a onclick='showDetails(\""+t.calendar.type.toLowerCase()+"\",\""+t.calendar.calendarId+"\")'><i class='fas fa-info-circle'></i></a>";
            }
        },

        postCreate: function() {
            var t = this;
            t.inherited(arguments);

            t.own(on(t.calendar,"changeColor",function() {
                domStyle.set(t.calendarIcon,"color",t.calendar.color.toHex());
            }));
        },

        openMenu: function() {
            var t = this;
            calendarMenu.opener = t;

            domStyle.set(removeMenuItem.domNode,"display",(t.calendar.type === "Holiday" ? "none" : ""));
            domStyle.set(changeColorMenuItem.domNode,"display",(t.calendar.type === "Holiday" ? "none" : ""));

            popup.open({
                parent: t,
                popup: calendarMenu,
                around: t.calendarMenuNode,
                onCancel: function() {
                    popup.close(calendarMenu);
                },
                onExecute: function() {
                    popup.close(calendarMenu);
                },
                onClose: function() {
                    popup.moveOffScreen(calendarMenu);
                }
            });

            on.once(t.calendarMenuNode,"blur",function() {
                popup.close(calendarMenu)
            });
        },

        remove: function() {
            var t = this;
            t.calendar.selected = false;
            t.calendarStore.put(t.calendar);
            //t.calendarStore.remove(t.calendar.id);
        },

        removeAllButThis: function() {
            var t = this;
            var i;
            t.parent._watchCalendarSelection = false;
            for (var i = t.calendarStore.data.length-1; i >= 0; i--) {
                var calendar = t.calendarStore.data[i];
                if (calendar.id !== t.calendar.id && calendar.type !== "Holiday") {
                    calendar.selected = false;
                    t.calendarStore.put(calendar);
                    //t.calendarStore.remove(calendar.id);
                }
            }
            t.parent._watchCalendarSelection = true;
            t.parent.onChangeSelectedCalendars(t.parent.getSelectedCalendars());
        }
	});
    
    var CalendarDetails = declare([_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_FocusMixin], {
		templateString: 
            "<div class='calendar-details' style='cursor:pointer'>" +
                "<div data-dojo-attach-point='expandNode' style='padding:5px;position:absolute;z-index:1'><span class='fas fa-angle-double-left'></span></div>" +
                "<div data-dojo-attach-point='collapseHeader' class='workspace-title calendarText'>Calendar Details</div>" +
                "<div data-dojo-attach-point='viewStack' style='height:100%;width:100%;display:none' data-dojo-type='dijit/layout/StackContainer'>" +
                    "<div data-dojo-attach-point='calendarView' data-dojo-type='dijit/layout/ContentPane'>" +
                        "<div data-dojo-type='thornberry/calendar/DatePicker' data-dojo-attach-point='miniCalendar' style='width:325px;margin-left:20px;'></div>" +
                        "<div style='margin-top:15px;'>" +
                            "<div class='workspace-title' style='display:inline-block'>Calendars</div>" +
                            "<div style='float:right' data-dojo-type='dijit/form/DropDownButton'>" +
                                "<span>Add</span>" +
                                "<div data-dojo-type='dijit/DropDownMenu'>" +
                                    "<div data-dojo-type='dijit/MenuItem' data-dojo-attach-event='onClick:_openPatientSearch'>Patient</div>" +
                                    "<div data-dojo-type='dijit/MenuItem' data-dojo-attach-event='onClick:_openEmployeeSearch'>Employee</div>" +
                                    (EnvironmentSettings.hospiceSite ? "<div data-dojo-type='dijit/MenuItem' data-dojo-attach-event='onClick:_openContactSearch'>Contact</div>" : "") +
                                "</div>" +
                            "</div>" +
                        "</div>" +
                        "<div data-dojo-attach-point='calendarContainer'></div>" +
                    "</div>" +
                    "<div data-dojo-attach-point='addView' data-dojo-type='dijit/layout/ContentPane' style='font-size:12pt'>" +
                        "<div style='margin-top:10px' data-dojo-type='thornberry/report/filter/Search' data-dojo-attach-point='search' data-dojo-props='cacheClass:\"Schedule.Calendar.Utility\",cacheMethod:\"SearchCalendars\"'></div>" +
                        "<button data-dojo-type='dijit/form/Button' data-dojo-attach-event='onClick:reset'>Cancel</button>" +
                    "</div>" +
                    "<div data-dojo-attach-point='employeeSearchView' data-dojo-type='dijit/layout/ContentPane'></div>" +
                    "<div data-dojo-attach-point='colorSelectView' data-dojo-type='dijit/layout/ContentPane' style='font-size:12pt'>" +
                        "<div data-dojo-attach-point='calendarNameNode' class='workspace-title' style='margin-top:10px;'></div>" + 
                        "<div data-dojo-type='dijit/ColorPalette' data-dojo-attach-point='colorSelect' data-dojo-props='palette:\"7x10\"' data-dojo-attach-event='onChange:selectColor'></div>" + 
                        "<button data-dojo-type='dijit/form/Button' data-dojo-attach-event='onClick:reset'>Cancel</button>" +
                        "<button disabled data-dojo-type='dijit/form/Button' data-dojo-attach-event='onClick:applyColorChange' data-dojo-attach-point='applyColorButton'>Apply</button>" +
                    "</div>" +
                    "<div data-dojo-attach-point='eventDetailsView' data-dojo-type='dijit/layout/ContentPane'>" +
                        "<div data-dojo-attach-event='onClick:onCloseEventDetails' style='position:relative;float:right;right: 5px;font-size:12pt;cursor:pointer;z-index: 9999;'><span class='fas fa-times'></span></div>" +
                        "<div data-dojo-attach-point='eventDetails' data-dojo-type='thornberry/calendar/EventDetails' style='position:relative;top: 15px;margin:8px;'></div>" +
                    "</div>" +
                    "<div data-dojo-attach-point='patientEmployeeDetailsView' data-dojo-type='dijit/layout/ContentPane'>" +
                        "<div data-dojo-attach-event='onClick:closePatientEmployeeDetails' style='position:relative;float:right;right: 5px;font-size:12pt;cursor:pointer;z-index: 9999;'><span class='fas fa-times'></span></div>" +
                        "<div data-dojo-attach-point='patientEmployeeDetails' style='position:relative;'></div>" +
                    "</div>" +
                "</div>" +
            "</div>",

        _isVisible: false, // true if currently displayed,

        calendarStore: null,
        currentCalendar: null,
        _calendarWidgetIndex: null,

        userSettings: null,

        frozen: false, // if true, then when Calendar Details is shown, it will not be hidden even if it loses focus

        _closeHandle: null,
        _openHandle: null,

        _watchCalendarSelection: true,

        postMixInProperties: function() {
			var t = this;
            t.inherited(arguments);
            
            t._calendarWidgetIndex = {};

            try {
                if (t.userSettings === null) {
                    var id = (typeof userId === "undefined" ? serverRequest("UI.Utility","GetUserId",{}) : userId);
                    when(id,function(value) {
                        t.userSettings = new UserSettings({
                            userId: value,
                            category: "_GENERAL"
                        });
                        t.userSettings.load();
                    });
                }
            } catch (e) {console.error(e)}
        },

        buildRendering: function() {
			var t = this;
			t.inherited(arguments);
            
            domStyle.set(t.domNode,"right","-"+COLLAPSEDWIDTH+"px");
            domStyle.set(t.domNode,"width",WIDTH+"px");
            
            domStyle.set(query(".dijitMultiSelect",t.search.domNode)[0],"width","100%");
            arrayUtils.forEach(query(".dijitButton",t.search.domNode),function(buttonNode) {
                domStyle.set(buttonNode,"display","none");
            });
            domStyle.set(t.search.selectedResults.domNode,"display","none");
        },

        postCreate: function() {
            var t = this;
            t.inherited(arguments);

            t._openHandle = on(t.domNode,"click",lang.hitch(t,"show"));

            t.own(on(window,"resize",function() {
				t.resize();
            }));

            var insertCalendar = function(calendar,position) {
                var calendarWidget = new CalendarWidget({parent:t,calendar:calendar,calendarStore:t.calendarStore});
                t._calendarWidgetIndex[calendar.id] = calendarWidget;
                domConstruct.place(calendarWidget.domNode,t.calendarContainer,position);
                calendarWidget.own(on(calendarWidget.checkBox,"change",function() {
                    if (t._watchCalendarSelection) {
                        t.onChangeSelectedCalendars(t.getSelectedCalendars());
                    }
                }));
            };
            
            t.calendarStore.query({selected:true},{sort:[{attribute:"name"}]}).observe(function(calendar,removedFrom,insertedInto) {
                if (insertedInto > -1) {insertCalendar(calendar,insertedInto)}
                if (removedFrom > -1) {
                    t._calendarWidgetIndex[calendar.id].destroy()
                    delete t._calendarWidgetIndex[calendar.id];
                }
                if (t._watchCalendarSelection) {
                    t.onChangeSelectedCalendars(t.getSelectedCalendars());
                }
            });
            arrayUtils.forEach(t.calendarStore.data,function(calendar) {insertCalendar(calendar)});

            t.search._searchOptions = function() {
                return { searchText: this.searchInput.get("value"), type: t.searchType };
            };
            t.search.formatResult = function (result) {
                // Summary: 
                //      This formats search results for display in the UI
                var pid = result.pid || result.cid;
                return result.name + " - " + pid + " - " + result.status;
            },
            t.search.searchInput.pattern = ".{3}.*";

            t.own(
                aspect.before(t.search,"_add",lang.hitch(t.search,"_removeAll")),
                aspect.after(t.search,"_add",lang.hitch(t,"addCalendar"))
            );

            topic.subscribe("event-removal",function(event) {
                if (t.eventDetails.event && t.eventDetails.event.id === event.id) {
                    t.closeEventDetails();
                }
            });
        },

        show: function() {
			var t = this;
			if (!t._isVisible) {
                if (t._openHandle) {
                    t._openHandle.remove();
                    t._openHandle = null;
                }

                t._isVisible = true;
                domStyle.set(t.viewStack.domNode,"display","block");
                domStyle.set(t.domNode,"cursor","");
                domStyle.set(t.collapseHeader,"display","none");
                t.reset();
                t.resize();
				fx.animateProperty({
					node: t.domNode,
					properties: {
						right: 0,
					},
					onEnd: function() {
                        t._isVisible = true;
                        t._focusManager.focus(t.domNode);
                        t.toggleExpand();
                        domStyle.set(t.expandNode,"cursor","pointer");
                        t._closeHandle = on(t.expandNode,"click",lang.hitch(t,"hide"));
                        if (t.calendar) {
                            domStyle.set(t.calendar.domNode,"right",WIDTH+"px");
                            t.calendar.resize();
                        }
					},
					duration: SLIDEDURATION
                }).play();
			}
		},
		
		hide: function() {
            var t = this;
            if (t._closeHandle) {
                t._closeHandle.remove();
                t._closeHandle = null;
            }
            t._isVisible = false;
            fx.animateProperty({
                node: t.domNode,
                properties: {
                    right:(-COLLAPSEDWIDTH)
                },
                onEnd: function() {
                    if (t._isVisible === false) {
                        domStyle.set(t.viewStack.domNode,"display","none");
                        t.toggleExpand();
                        domStyle.set(t.domNode,"cursor","pointer");
                        domStyle.set(t.expandNode,"cursor","");
                        domStyle.set(t.collapseHeader,"display","");
                        t._openHandle = on(t.domNode,"click",lang.hitch(t,"show"));
                    }
                },
                duration: SLIDEDURATION
            }).play();
            if (t.calendar) {
                domStyle.set(t.calendar.domNode,"right",(WIDTH-COLLAPSEDWIDTH)+"px");
                t.calendar.resize();
            }
        },
        
        resize: function() {
            var t = this;
            t.inherited(arguments);
            t.viewStack.resize();
        },

        setSelectedCalendars: function(calendarIds) {
            var t = this;
            var lastVal = t._watchCalendarSelection;
            t._watchCalendarSelection = false;
            for (calendarId in t._calendarWidgetIndex) {
                t._calendarWidgetIndex[calendarId].checkBox.set("checked", arrayUtils.some(calendarIds,function(checkId) {return checkId === calendarId;}));
            }
            t.defer(function() {
                t._watchCalendarSelection = lastVal;
                t.onChangeSelectedCalendars(t.getSelectedCalendars());
            });
        },

        getSelectedCalendars: function() {
            var t = this;
            var calendarIds = [];
            for (calendarId in t._calendarWidgetIndex) {
                var calendarWidget = t._calendarWidgetIndex[calendarId];
                if (calendarWidget.checkBox.get("checked")) {
                    calendarIds.push(calendarWidget.calendar.id);
                }
            }
            return calendarIds;
        },

        _openPatientSearch: function() {
            this.searchType = "Patient";
            this.openCalendarSelect();
        },

        _openEmployeeSearch: function() {
            var t = this;
            t.searchType = "Employee";
            if (!t.employeeSearchForm) {
                domStyle.set(t.employeeSearchView.domNode,"padding","0px");
                t.employeeSearchForm = new AdvancedEmployeeSearch({
                    intent: "view",
                });
                domStyle.set(t.employeeSearchForm.searchFormPane,"padding","15px 0px 0px 0px");
                domStyle.set(t.employeeSearchForm.searchResultsPane,"padding","15px 0px 0px 0px");
                t.employeeSearchView.domNode.appendChild(t.employeeSearchForm.domNode);
                on(t.employeeSearchForm,"cancel",function() {
                    t.reset();
                });
                on(t.employeeSearchForm,"select",function(employees) {
                    if (employees && employees.length > 0) {
                        t.addCalendar();
                    }
                });
            } else {
                t.employeeSearchForm.reset();
            }
            t.viewStack.selectChild(t.employeeSearchView);
        },

        _openContactSearch: function() {
            this.searchType = "Contact";
            this.openCalendarSelect();
        },

        openCalendarSelect: function() {
            var t = this;
            t.resetSearch();
            t.viewStack.selectChild(t.addView);
        },

        addCalendar: function() {
            var t = this;
            var selectedType = t.searchType;
            var selectedIds = t.search.get("value");

            if (selectedType === "Employee") {
                selectedIds = arrayUtils.map(t.employeeSearchForm.get("selectedEmployees"),function(user){return user.empId});
            }

            if (selectedIds.length > 0) {
                serverRequest("Schedule.Calendar.Utility","OpenCalendarResult",{type:selectedType,ids:selectedIds}).then(function(calendars) {
                    t._watchCalendarSelection = false;
                    arrayUtils.forEach(calendars,function(calendar) {
                        var existingCalendar = t.calendarStore.get(calendar.id);
                        if (!existingCalendar) {
                            calendar.selected = true;
                            t.calendarStore.put(new Calendar(calendar));
                        } else {
                            existingCalendar.selected = true;
                            t.calendarStore.put(existingCalendar);
                            var widget = t._calendarWidgetIndex[calendar.id];
                            if (!widget.checkBox.get("checked")) {
                                widget.checkBox.set("checked",true);
                            }
                        }
                        // Maintain constraint that only one non-employee calendar be included at a time
                        if (calendar.type === "Patient" || calendar.type === "Contact") {
                            arrayUtils.some(t.calendarStore.data,function(storeCalendar) {
                                if (storeCalendar.id !== calendar.id && (storeCalendar.type === "Patient" || storeCalendar.type === "Contact") && storeCalendar.selected) {
                                    storeCalendar.selected = false;
                                    t.calendarStore.put(storeCalendar);
                                    return true;
                                }
                                return false;
                            });
                        }
                    });
                    t._watchCalendarSelection = true;
                    t.onChangeSelectedCalendars(t.getSelectedCalendars());
                });
            }

            t.reset();
        },

        showEventDetails: function(calendar,event) {
            this.viewStack.selectChild(this.eventDetailsView);
            this.eventDetails.setEvent(calendar,event);
        },

        showPatientEmployeeDetails: function(calendarType,calendarId) {
            var t = this;
            t.show();
            if (t.detailsWidget) {
                if (typeof t.detailsWidget.recycle !== "undefined") {
                    t.detailsWidget.recycle();
                } else {
                    t.detailsWidget.destroyRecursive();
                }
            }
            this.viewStack.selectChild(this.patientEmployeeDetailsView);
            var infoLink = new InfoLink({entityType:calendarType});
            t.detailsWidget = infoLink._getDetailPane(calendarId,true);
            domConstruct.place(t.detailsWidget.domNode,t.patientEmployeeDetails);
        },

        closeEventDetails: function() {
            this.viewStack.selectChild(this.calendarView);
        },

        closePatientEmployeeDetails: function() {
            if (this.viewStack.selectedChildWidget === this.patientEmployeeDetailsView) {
                if (this.calendar.selectedItem) {
                    this.viewStack.selectChild(this.eventDetailsView);
                } else {
                    this.viewStack.selectChild(this.calendarView);
                }
            }
        },

        onCloseEventDetails: function() {},

        reset: function() {
            if (this.viewStack.selectedChildWidget !== this.eventDetailsView) {
                this.viewStack.selectChild(this.calendarView);
            }
            this.colorSelect.set("value","");
            this.currentCalendar = null;
            this.resetSearch();
        },

        resetSearch: function() {
            this.search._removeAll();
            this.search.searchInput.set("value","");
            this.search.searchInput.defer("focus");
            this.search.resultsSelect.removeOption(this.search.resultsSelect.getOptions());
            this.search.resultsSelect._setDisplay("");
        },

        toggleExpand: function() {
            var t = this;
            var span = query("span",t.expandNode)[0];
            domClass.toggle(span,"fa-angle-double-right");
            domClass.toggle(span,"fa-angle-double-left");
        },

        openColorSelect: function(calendarWidget) {
            var t = this;
            t.viewStack.selectChild(t.colorSelectView);
            t.calendarNameNode.innerHTML = calendarWidget.calendar.name;
            t.currentCalendar = calendarWidget.calendar;
        },

        selectColor: function() {
            var t = this;
            var color = t.colorSelect.get("value");
            t.applyColorButton.set("disabled",(color === null));
        },

        applyColorChange: function() {
            var t = this;
            var color = t.colorSelect.get("value");
            t.currentCalendar.setColor(color);
            t.onChangeSelectedCalendars(t.getSelectedCalendars());
            t.reset();
        },

        onChangeSelectedCalendars: function(selectedIds) {}
	});
	
	return CalendarDetails;
});